#!c:/python27/python.exe
#encoding: utf-8

import sys,time,re,os,tempfile,getopt,shutil




def helpme():
    print """Usage:
%s [-e installer.exe] -l [filename]
    Read list of available voices from Ivona servers
    and store in file (if name given) on prints to stdout
%s [-e installer.exe] [options] voices
    Download given voices. Options are:
    -d directory - download into this directory instead of current
    -c           - don't download Ivona Control Center
    -v           - verbose mode
%s [-e installer.exe] [options] -i
    Download Ivona Control Center only. Options are:
    -d directory - download into this directory instead of current
    -v           - verbose mode
""" % (sys.argv[0],sys.argv[0],sys.argv[0])
    exit(1)
    
command=None
voices=None
dirname=None
voicefile=None
nocc=False
installer=None
verbose=None

opts, args= getopt.getopt(sys.argv[1:],"ld:ice:hv")
for opt in opts:
    if opt[0] == '-h':
        helpme()
        
    if opt[0] == '-c':
        if command and command != 'download':
            helpme()
        command='download'
        nocc=True
        continue
    if opt[0] == '-d':
        dirname=opt[1]
        continue
    if opt[0] == '-i':
        if command and command != 'downcenter':
            helpme()
        command='downcenter'
        continue
    if opt[0] == '-l':
        if command and command != 'list':
            helpme()
        command='list'
        continue
    if opt[0] == '-e':
        installer=opt[1]
        continue
    if opt[0] == '-v':
        verbose=True
        continue
if not command:
    command='download'

if command == 'download':
    if len(args) == 0:
        helpme()
    voices=[]
    for a in args:
        if not isinstance(a,unicode):
            a=a.decode('utf-8')
        voices.append(a)
elif command == 'list':
    if len(args)>1:
        helpme()
    if len(args) == 1:
        voicefile=args[0]
    if dirname or nocc:
        helpme()
elif command == 'downcenter':
    if nocc:
        helpme()

base=os.getcwd()
if not dirname:
	dirname=base
else:
	dirname=os.path.join(base,dirname)

ivona_exe_names=[
		os.path.join(base,'ivona_install.exe'),
		os.path.join(base,'data/ivona_install.exe'),
		os.path.join(os.environ['TMP'],"ivona_install.exe")]

def download_installer():
    global ivona_exe_names
    import urllib2
    download_path='http://download.instalki.pl/programy/Windows/Multimedia/syntezatory_mowy/ivona_installer_ne_www.INSTALKI.pl.exe'
    handler=urllib2.HTTPRedirectHandler()
    opener=urllib2.build_opener(handler)
    opener.addheaders = [ ('User-Agent','Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)')]
    print "Downloading Ivona installer"
    f=opener.open(download_path,timeout=30)
    pagecode=f.read()
    fb=None
    for a in ivona_exe_names:
        try:
            g=open(a,'wb')
            fb=a
            break
        except:
            pass
    if not fb:
        print "Cannot open installer for write"
        sys.exit(1)
    g.write(pagecode)
    g.close()
    return fb
    

if not installer:
    for fd in ivona_exe_names:
        if os.path.exists(fd):
            installer=fd
            break
    if not installer:
        installer=download_installer()
print installer

from pywinauto import application,controls

app=application.Application.start(installer)

try:
    app.IvonaSetupLanguage.ComboBox1.Select('English')
    app.IvonaSetupLanguage.OK.Click()
    time.sleep(0.25)
    app.IvonaSetup.Next.Click()
except:
    app.Kill_()
    print "Cannot initialize Ivona Downloader"
    exit(1)

def megabytes():
    global app
    for n in range(1,5):
        va=app.IvonaSetup._ctrl_identifiers()
        for key in va.iterkeys():
            txt=key.WindowText().strip().lower()
            r=re.match(r'^([0-9]+)\s+mb to be downloaded from',txt)
            if r:
                return int(r.group(1))
        print "MB widget not found"
        time.sleep(1.5)
    app.Kill_()
    print "Cannot read megabytes"
    exit(0)
    
def findDIInfo():
    global app
    for n in range(1,5):
        va=app.IvonaSetup._ctrl_identifiers()
        for key in va.iterkeys():
            txt=key.WindowText().strip().lower()
            r=re.match(r'.*(download|install)ing:\s*(.*?)\s*(\(.*?\)|$)',txt)
            if r:
                return r.group(1)[0],r.group(2),r.group(3)
        print "Downinstall widget not found"
        time.sleep(1.5)
    app.Kill_()
    print "Cannot read downinstall info"
    exit(0)
            
        




f=False
for i in range(1,50):
    try:
        app.IvonaSetup.IAgree.Click()
        f=True
        break
    except:
        pass
if not f:
    app.Kill_()
    print "Cant find license button"
    exit(1)

app.IvonaSetup.RadioButton1.Click()
app.IvonaSetup.Next.Click()

time.sleep(0.25)

root=app.IvonaSetup.TreeView.Root()
n=0

voxlist={}
voxpos={}
icc=None

def examb(root,nr):
    global voxpos,icc
    root.tree_ctrl.EnsureVisible((nr,))
    name=root.Text().strip()
    isVoice = (name.find('voice') > 0)
    a=[]
    for n,child in enumerate(root.Children()):
        root.tree_ctrl.EnsureVisible((nr,n))
        s=child.Text()
        if not isVoice:
            if s.lower().find('control') >= 0:
                icc=(nr,n)
        else:
            s=s.split()[0]
            s=s.replace(u'ó',u'o').replace(u'é',u'e')
            a.append(s)
            voxpos[s.lower()]=(nr,n)
    if isVoice:
        voxlist[nr]=[name,a]
    
if command == 'list':
    while root:
        examb(root,n)
        root=root.Next()
        if not root:
            break
        n += 1
    
    app.Kill_()
    if voicefile:
        f=open(voicefile,'w')
    else:
        f=sys.stdout
    for lang in voxlist:
        lang=voxlist[lang]
        f.write("%s:\n" % lang[0])
        f.write("%s\n" % ", ".join(lang[1]))
    exit(0)




def examineBranch(root,nr):
    global voxpos,icc
    #root.tree_ctrl.EnsureVisible((nr,))
    name=root.Text().strip()
    isVoice = (name.find('voice') > 0)
    a=[]
    for n,child in enumerate(root.Children()):
        s=child.Text()
        if not isVoice:
            if s.lower().find('control') >= 0:
                icc=(nr,n)
        else:
            s=s.split()[0]
            s=s.replace(u'ó',u'o').replace(u'é',u'e')
            a.append(s)
            voxpos[s.lower()]=(nr,n)
        m1=megabytes()
        m2=m1
        sx=child.State() & 0x2000
        if sx:
            root.tree_ctrl.EnsureVisible((nr,n))
            child.Click(where='text')
            app.IvonaSetup.TypeKeys('{SPACE}')
            m2=megabytes()
    if isVoice:
        voxlist[nr]=[name,a]
    
    
while root:
    examineBranch(root,n)
    root=root.Next()
    if not root:
        break
    n += 1

ncount=n

#print voxlist
#print "----"
#print voxpos

if megabytes():
    print "Cannot zero megabytes, try again"
    app.Kill_()
    exit(1)

if command =='download':
    for vox in voices:
        bv=voxpos.get(vox.lower(),None)
        if not bv:
            print "Voice %s not found" % vox
            exit(1)
        app.IvonaSetup.TreeView.EnsureVisible(bv)
        elem=app.IvonaSetup.TreeView.GetItem(bv)
        elem.Click()
        app.IvonaSetup.TypeKeys('{SPACE}')

if command == 'downcenter' or (command == 'download' and not nocc):
    if not icc:
        print "Control Center not found"
        app.Kill_()
        exit(1)
    app.IvonaSetup.TreeView.EnsureVisible(icc)
    elem=app.IvonaSetup.TreeView.GetItem(icc)
    elem.Click()
    time.sleep(1)
    app.IvonaSetup.TypeKeys('{SPACE}')
    
    


ivonadir=os.path.join(os.environ['TMP'],"ivona")
known_temps=set()

def gettemps():
    global known_temps,ivonadir
    try:
        dy=os.listdir(ivonadir)
    except WindowsError:
        return []
    sl=[]
    for a in dy:
        if a in known_temps:
            continue
        if a.endswith(".tmp.dat"):
            sl.append(a)
    return sl

known_temps=set(gettemps())

print "%d MB to download:" % (megabytes(),)

app.IvonaSetup.Next.Click()

dling=None

def nameofvox(t):
    if t.find('center') >= 0:
        return "control.dat"
    return t.replace(u'ó',u'o').replace(u'é',u'e')+".dat"

to_copy=[]

def flush_to_copy():
    global to_copy,ivonadir,dirname
    while len(to_copy) > 0:
        p=to_copy.pop(0)
        fra=os.path.join(ivonadir,p[0])
        til=p[1]
        if dirname:
            til=os.path.join(dirname,til)
        print "Copying %s to %s" % (fra,til)
        shutil.copyfile(fra,til)

pcy=""

while True:
    time.sleep(0.25)
    mode,vox,pcx=findDIInfo()
    if mode == 'i':
        app.Kill_()
        flush_to_copy()
        break
    if dling == vox:
        if verbose and pcy != pcx:
            pcy = pcx
            print vox,pcx
        continue
    temps=gettemps()
    if len(temps) == 0:
        continue
    if len(temps) > 1:
        print "Too many temporary files"
        app.Kill_()
        exit(1)
    temp=temps[0]
    known_temps.add(temp)
    print "Started download:",vox
    dling=vox
    pcy=""
    fname=nameofvox(dling)
    #print "%s will be %s" % (temp,fname)
    #flush_to_copy()
    to_copy.append((temp,fname))

app.Kill_()
